# `$route` (service in module `ng` )

Improve this doc

## Description

Is used for deep-linking URLs to controllers and views (HTML partials). It watches `$location.url()` and tries to map the path to an existing route definition.

You can define routes through `$routeProvider`'s API.

The `$route` service is typically used in conjunction with `ngView` directive and the `$routeParams` service.

## Dependencies

- `$location`
- `$routeParams`

## Methods

- ### reload()

  Causes `$route` service to reload the current route even if `$location` hasn't changed.

  As a result of that, `ngView` creates new scope, reinstantiates the controller.

## Properties

- ### current

  Reference to the current route definition. The route definition contains:

  - `controller`: The controller constructor as define in route definition.

  - `locals`: A map of locals which is used by `$controller` service for controller instantiation. The `locals` contain the resolved values of the `resolve` map. Additionally the `locals` also contain:

    - `$scope` - The current route scope.
    - `$template` - The current route template HTML.

- ### routes

  Array of all configured routes.

## Events

- ### $routeChangeError

  Broadcasted if any of the resolve promises are rejected.

  #### Type:

  broadcast

  #### Target:

  root scope

  #### Parameters

  - `current – {Route} –`

    Current route information.

  - `previous – {Route} –`

    Previous route information.

  - `rejection – {Route} –`

    Rejection of the promise. Usually the error of the failed promise.

- ### $routeChangeStart

  Broadcasted before a route change. At this point the route services starts resolving all of the dependencies needed for the route change to occurs. Typically this involves fetching the view template as well as any dependencies defined in `resolve` route property. Once all of the dependencies are resolved `$routeChangeSuccess` is fired.

  #### Type:

  broadcast

  #### Target:

  root scope

  #### Parameters

  - `next – {Route} –`

    Future route information.

  - `current – {Route} –`

    Current route information.

- ### $routeChangeSuccess

  Broadcasted after a route dependencies are resolved. `ngView` listens for the directive to instantiate the controller and render the view.

  #### Type:

  broadcast

  #### Target:

  root scope

  #### Parameters

  - `angularEvent – {Object} –`

    Synthetic event object.

  - `current – {Route} –`

    Current route information.

  - `previous – {Route|Undefined} –`

    Previous route information, or undefined if current is first route entered.

- ### $routeUpdate

  The `reloadOnSearch` property has been set to false, and we are reusing the same instance of the Controller.

  #### Type:

  broadcast

  #### Target:

  root scope

## Example

This example shows how changing the URL hash causes the `$route` to match a route against the URL, and the `ngView` pulls in the partial.

Note that this example is using `inlined templates` to get it working on jsfiddle as well.

#### Source

#### Demo